// EBTB1200 IO Labrary by NKJ.

void gpio_init(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;
  
  ////////// GPIO CLOCK ENABLE //////////
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);  //  GPIOA clock enable.. 
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, ENABLE);  //  GPIOB clock enable..
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC, ENABLE);  //  GPIOC clock enable..  
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO, ENABLE);  //   AFIO clock enable..    
  GPIO_PinRemapConfig(GPIO_Remap_SWJ_Disable, ENABLE);   // Full SWJ Disabled (JTAG-DP + SW-DP)  
  
  ////////// GPIOA INIT //////////
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0|GPIO_Pin_1|GPIO_Pin_2|GPIO_Pin_3|GPIO_Pin_4|GPIO_Pin_5|GPIO_Pin_6|GPIO_Pin_7;  // CM_IOD0 ~ CM_IOD7
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;  // input FLOATING
  GPIO_Init(GPIOA,&GPIO_InitStructure);   // portA init..  

  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8|GPIO_Pin_11|GPIO_Pin_12|GPIO_Pin_13|GPIO_Pin_14|GPIO_Pin_15;  // LCD_BL, CM_RD_DATA, CM_RDY_CAP, LCD_CS, LCD_RS, LCD_WR
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;  // output push-pull
  GPIO_Init(GPIOA,&GPIO_InitStructure);   // portA init..  

  ////////// GPIOB INIT //////////  
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1|GPIO_Pin_5;  // CM_END_CAP, PEN_IRQ
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;  // input pull-up
  GPIO_Init(GPIOB,&GPIO_InitStructure);   // portB init..    
  
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0|GPIO_Pin_3|GPIO_Pin_4|GPIO_Pin_6|GPIO_Pin_7|GPIO_Pin_8|GPIO_Pin_9|GPIO_Pin_12|GPIO_Pin_13|GPIO_Pin_14|GPIO_Pin_15;  // CM_START_CAP, LCD_RESET, LCD_RD, TOUCH_SCL, TOUCH_SDA, CM_ADDR_BYTE0, CM_ADDR_BYTE1, CM_ADDR_DET, CM_RESET, CM_SIOC, CM_SIOD
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;  // output push-pull
  GPIO_Init(GPIOB,&GPIO_InitStructure);   // portB init..    
  
  ////////// GPIOC INIT //////////    
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_All;  // LCD_D0 ~ LCD_D15
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;  // output push-pull
  GPIO_Init(GPIOC,&GPIO_InitStructure);   // portB init..      
  
}

#define CmEndCapture   (BBIO(GPIOB->IDR,1))
//#define CmEndCapture  (GPIOB->IDR & GPIO_Pin_1)

#define CmReset_H  (GPIOB->BSRR = GPIO_Pin_13)
#define CmReset_L  (GPIOB->BRR = GPIO_Pin_13)
//#define CmReset(X)       (BBIO(GPIOB->ODR,13)=X)

#define CmAddrClock_H (GPIOB->BSRR = GPIO_Pin_12)
#define CmAddrClock_L (GPIOB->BRR = GPIO_Pin_12)

#define CmAddr1_H (GPIOB->BSRR = GPIO_Pin_9)
#define CmAddr1_L (GPIOB->BRR = GPIO_Pin_9)

#define CmAddr0_H (GPIOB->BSRR = GPIO_Pin_8)
#define CmAddr0_L (GPIOB->BRR = GPIO_Pin_8)

#define CmRdData_H (GPIOA->BSRR = GPIO_Pin_11)
#define CmRdData_L (GPIOA->BRR = GPIO_Pin_11)

#define CmData     ((unsigned char)GPIOA->IDR)

#define CmReady_H (GPIOA->BSRR = GPIO_Pin_12)
#define CmReady_L (GPIOA->BRR = GPIO_Pin_12)

#define CmCapture_H (GPIOB->BSRR = GPIO_Pin_0)
#define CmCapture_L (GPIOB->BRR = GPIO_Pin_0)

void CmSetAddress(unsigned long addr)
{
  
  GPIOA->CRL=0x33333333;   // CM_IOD0 ~ CM_IOD7 : OUTPUT_PUSH-PULL

  CmAddr1_L; CmAddr0_H;
  GPIOA->BRR=0x00ff; 
  GPIOA->BSRR=addr&0xff;
  CmAddrClock_H;
  CmAddrClock_L;
  
  CmAddr1_H; CmAddr0_L;
  GPIOA->BRR=0x00ff; 
  GPIOA->BSRR=(addr>>8)&0xff; 
  CmAddrClock_H;
  CmAddrClock_L;  
  
  CmAddr1_H; CmAddr0_H;
  GPIOA->BRR=0x00ff; 
  GPIOA->BSRR=(addr>>16)&0xff;
  CmAddrClock_H;
  CmAddrClock_L;  
  
  CmAddr1_L; CmAddr0_L;
  
  GPIOA->CRL=0x44444444;   // CM_IOD0 ~ CM_IOD7 : INPUT_FLOATING
}


#define LcdBl_H  (GPIOA->BSRR = GPIO_Pin_8)  // 1
#define LcdBl_L  (GPIOA->BRR = GPIO_Pin_8)   // 0

#define LcdRd_H  (GPIOB->BRR = GPIO_Pin_4)   // 0  Low Active
#define LcdRd_L  (GPIOB->BSRR = GPIO_Pin_4)  // 1

#define LcdWr_H  (GPIOA->BRR = GPIO_Pin_15)  // 0  Low Active
#define LcdWr_L  (GPIOA->BSRR = GPIO_Pin_15) // 1

#define LcdRs_H  (GPIOA->BSRR = GPIO_Pin_14) // 1
#define LcdRs_L  (GPIOA->BRR = GPIO_Pin_14)  // 0

#define LcdCs_H  (GPIOA->BRR = GPIO_Pin_13)  // 0  Low Active
#define LcdCs_L  (GPIOA->BSRR = GPIO_Pin_13) // 1

#define LcdData     (GPIOC->ODR)    // format : (rrrrrggg gggbbbbb)binary

#define LcdReset_H  (GPIOB->BRR = GPIO_Pin_3) // 0  Low Active
#define LcdReset_L  (GPIOB->BSRR = GPIO_Pin_3)// 1
                         
#define PenIrq      (!(BBIO(GPIOB->IDR,5)))  // Low Active
//#define PenIrq      (!(GPIOB->IDR & GPIO_Pin_5))

