#include "stm32f10x.h"
#include "sys.c"
#include "io.c"
#include "i3202lcd.c"
#include "graphic.c"


void lcd_clear(void)
{                  
  unsigned int n,m;
  
  LcdSetWindow(0,0,320,240);
  LcdDataStart();
  for(n=0;n<320;n++)
   {  for(m=0;m<240;m++) { LcdDataWrite(0xffff); }
   }
  LcdDataEnd();
}

int main(void)
{
  unsigned int x,y; 
  
  gpio_init();
  rcc_init();  
  uart_init1();

  mdelay(1000);  // wait for flash loader communication...
  put_string1("\n Graphic");
  
  LcdInit();                
  LcdBl_H;  

  LcdSetDirection(90);
  lcd_clear();
  
  for(x=0;x<50;x++)
    { circle(100,100,x,RGB(250-x*5,x*5,0));
    }


  for(x=0;x<50;x+=1)
    {  rectangle(230+x,30+x,30,50,RGB(x*5,x*5,x*5));
    }    


  for(x=0,y=100;x<100;x+=5,y+=5)
   {
       line(0,y,x,200,0x07e0);
   }
   
  for(x=0,y=100;x<100;x+=5,y-=5)
   {
       line(0,y,x,0,0xf800);
   }   

  for(x=100,y=0;x<200;x+=5,y+=5)
   {
       line(x,0,200,y,0xffe0);
   }   

  for(x=100,y=200;x<200;x+=5,y-=5)
   {
       line(x,200,200,y,0x001f);
   }   


    
  while(1)
  {
    
  }                                  
}  